# Changelog

## [1.0.0](https://github.com/trento-project/web/tree/1.0.0) (2022-04-29)

[Full Changelog](https://github.com/trento-project/web/compare/df6d355b2b955d6902f279cda3cd63f0865ab95c...1.0.0)

**Implemented enhancements:**

- EULA is only showed after a page refresh [\#397](https://github.com/trento-project/web/issues/397)
- Add mailer for important alerts [\#58](https://github.com/trento-project/web/issues/58)
- Suse delivery [\#408](https://github.com/trento-project/web/pull/408) ([arbulu89](https://github.com/arbulu89))
- Implement the collapsable sidebar [\#344](https://github.com/trento-project/web/pull/344) ([arbulu89](https://github.com/arbulu89))
- Update execution request payload to use one cluster [\#336](https://github.com/trento-project/web/pull/336) ([arbulu89](https://github.com/arbulu89))
- Handle unreachable checks execution scenario [\#304](https://github.com/trento-project/web/pull/304) ([arbulu89](https://github.com/arbulu89))
- Integrate real runner execution usage [\#300](https://github.com/trento-project/web/pull/300) ([arbulu89](https://github.com/arbulu89))
- Add query parameters for catalog controller [\#296](https://github.com/trento-project/web/pull/296) ([arbulu89](https://github.com/arbulu89))
- Get catalog from runner [\#257](https://github.com/trento-project/web/pull/257) ([arbulu89](https://github.com/arbulu89))
- Add checks catalog view [\#241](https://github.com/trento-project/web/pull/241) ([arbulu89](https://github.com/arbulu89))

**Fixed bugs:**

- "cloudadmin" set as default as connection settings user in azure [\#419](https://github.com/trento-project/web/issues/419)
- Connection settings switch doing funky things [\#410](https://github.com/trento-project/web/issues/410)
- Improve sap instance parsing to use the hostname to get the fields [\#475](https://github.com/trento-project/web/pull/475) ([arbulu89](https://github.com/arbulu89))
- Update the usage of the spinner icon during checks execution [\#467](https://github.com/trento-project/web/pull/467) ([arbulu89](https://github.com/arbulu89))
- Filter correctly the check results by host [\#451](https://github.com/trento-project/web/pull/451) ([arbulu89](https://github.com/arbulu89))
- Fix connection settings switch for when the input is empty [\#449](https://github.com/trento-project/web/pull/449) ([arbulu89](https://github.com/arbulu89))
- Handle aws clusters empty lists [\#448](https://github.com/trento-project/web/pull/448) ([arbulu89](https://github.com/arbulu89))
- Fix regression in Dockerfile [\#427](https://github.com/trento-project/web/pull/427) ([arbulu89](https://github.com/arbulu89))
- Fix sap system column usage in the host list overview [\#387](https://github.com/trento-project/web/pull/387) ([arbulu89](https://github.com/arbulu89))
- Fix cloud details fields [\#370](https://github.com/trento-project/web/pull/370) ([arbulu89](https://github.com/arbulu89))

**Closed issues:**

- Checks catalog error message on unknown provider is not meaningful enough [\#433](https://github.com/trento-project/web/issues/433)
- Detect and show Virtual IP in Pacemaker Site details \(Cluster detail page\) [\#389](https://github.com/trento-project/web/issues/389)
- If System replication has changed in a database instance, we should emit an event and project the new values [\#384](https://github.com/trento-project/web/issues/384)
- Pushing data for the first time with photofinish while on the host overview results in an error [\#382](https://github.com/trento-project/web/issues/382)
- Correctly detect Pacemaker Site details in ClusterDetails [\#381](https://github.com/trento-project/web/issues/381)
- use cluster discovered provider in checks execution request [\#380](https://github.com/trento-project/web/issues/380)
- Host overview could reuse the already existing getInstancesOnHost selector [\#375](https://github.com/trento-project/web/issues/375)
- CIB last written command enrichment broadcasted event resets checks selection redux state [\#366](https://github.com/trento-project/web/issues/366)
- Missing error boundary for the single-page app [\#319](https://github.com/trento-project/web/issues/319)
- Guard against empty tags [\#305](https://github.com/trento-project/web/issues/305)
- Display prominent notification messages [\#258](https://github.com/trento-project/web/issues/258)
- Using new! in case of nested errors raises without reporting the actual error [\#251](https://github.com/trento-project/web/issues/251)
- Add links to cluster detail, when possible [\#242](https://github.com/trento-project/web/issues/242)
- Add System Replication to HANA databases overview. [\#219](https://github.com/trento-project/web/issues/219)
- Remove extra query in projectors when updating read models [\#207](https://github.com/trento-project/web/issues/207)
- Add read\_model suffix to read model tables [\#201](https://github.com/trento-project/web/issues/201)
- Add the missing tests for the tags creation/deletion [\#198](https://github.com/trento-project/web/issues/198)
- Cluster checks related, command and aggregate logic are not tested [\#101](https://github.com/trento-project/web/issues/101)
- HostDetailsUpdated is missing from host\_projector tests [\#80](https://github.com/trento-project/web/issues/80)
- Add discovery integration event parsing tests [\#69](https://github.com/trento-project/web/issues/69)
- Filter ipv6 and loopbacks from host ip addresses [\#63](https://github.com/trento-project/web/issues/63)
- Add factory/fixtures library to the mix [\#57](https://github.com/trento-project/web/issues/57)
- Add HostDetailsUpdated events [\#56](https://github.com/trento-project/web/issues/56)
- Emit HostRegistered when UpdateHeartbeatStatus is received before the host registration [\#55](https://github.com/trento-project/web/issues/55)
- Update configuration for Tailwind v3.0 [\#54](https://github.com/trento-project/web/issues/54)
- Enable Phoenix hot reload and double check Domo compile time structs [\#53](https://github.com/trento-project/web/issues/53)
- Proposal: Switch to domo instead of middleware for command validation [\#52](https://github.com/trento-project/web/issues/52)
- Check enum libraries for compile time enums [\#49](https://github.com/trento-project/web/issues/49)
- Add test for monitoring context [\#47](https://github.com/trento-project/web/issues/47)
- Add validate middleware tests [\#40](https://github.com/trento-project/web/issues/40)
- Use credo strict [\#35](https://github.com/trento-project/web/issues/35)

**Merged pull requests:**

- Bump docker/metadata-action from 3.7.0 to 3.8.0 [\#473](https://github.com/trento-project/web/pull/473) ([dependabot[bot]](https://github.com/apps/dependabot))
- Fix html element hierarchy [\#471](https://github.com/trento-project/web/pull/471) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fix double scrollbar layout, take two [\#470](https://github.com/trento-project/web/pull/470) ([dottorblaster](https://github.com/dottorblaster))
- Bump swoosh from 1.6.5 to 1.6.6 [\#469](https://github.com/trento-project/web/pull/469) ([dependabot[bot]](https://github.com/apps/dependabot))
- Prune old events [\#468](https://github.com/trento-project/web/pull/468) ([fabriziosestito](https://github.com/fabriziosestito))
- Rename dev environment by default [\#466](https://github.com/trento-project/web/pull/466) ([arbulu89](https://github.com/arbulu89))
- Update CD job [\#465](https://github.com/trento-project/web/pull/465) ([stefanotorresi](https://github.com/stefanotorresi))
- Fixes start execution trigger [\#463](https://github.com/trento-project/web/pull/463) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fix dashboard [\#462](https://github.com/trento-project/web/pull/462) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump jest from 28.0.1 to 28.0.2 in /assets [\#461](https://github.com/trento-project/web/pull/461) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump babel-jest from 28.0.1 to 28.0.2 in /assets [\#459](https://github.com/trento-project/web/pull/459) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump eventstore from `085602a` to `9883f4a` [\#458](https://github.com/trento-project/web/pull/458) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump axios from 0.27.1 to 0.27.2 in /assets [\#457](https://github.com/trento-project/web/pull/457) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump postgrex from 0.16.2 to 0.16.3 [\#456](https://github.com/trento-project/web/pull/456) ([dependabot[bot]](https://github.com/apps/dependabot))
- Revert "Fix double scrollbars" [\#455](https://github.com/trento-project/web/pull/455) ([dottorblaster](https://github.com/dottorblaster))
- Fix alerts event handler ArgumentError when disabled [\#454](https://github.com/trento-project/web/pull/454) ([fabriziosestito](https://github.com/fabriziosestito))
- Change discovery notification icon [\#453](https://github.com/trento-project/web/pull/453) ([fabriziosestito](https://github.com/fabriziosestito))
- Add sign out link [\#452](https://github.com/trento-project/web/pull/452) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix double scrollbars [\#450](https://github.com/trento-project/web/pull/450) ([dottorblaster](https://github.com/dottorblaster))
- fix instance identification when only hana db available [\#447](https://github.com/trento-project/web/pull/447) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fix System Replication nil values projection [\#446](https://github.com/trento-project/web/pull/446) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump jest from 28.0.0 to 28.0.1 in /assets [\#445](https://github.com/trento-project/web/pull/445) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump axios from 0.27.0 to 0.27.1 in /assets [\#444](https://github.com/trento-project/web/pull/444) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump swoosh from 1.6.4 to 1.6.5 [\#443](https://github.com/trento-project/web/pull/443) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump babel-jest from 28.0.0 to 28.0.1 in /assets [\#441](https://github.com/trento-project/web/pull/441) ([dependabot[bot]](https://github.com/apps/dependabot))
- Forward cluster\_details\_updated event to the FE [\#440](https://github.com/trento-project/web/pull/440) ([fabriziosestito](https://github.com/fabriziosestito))
- Read database instances from the proper slice of state [\#438](https://github.com/trento-project/web/pull/438) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Use real sites instead of placeholders [\#437](https://github.com/trento-project/web/pull/437) ([fabriziosestito](https://github.com/fabriziosestito))
- Add notification message for non supported providers for checks [\#436](https://github.com/trento-project/web/pull/436) ([arbulu89](https://github.com/arbulu89))
- Selected checks are now reactive [\#435](https://github.com/trento-project/web/pull/435) ([fabriziosestito](https://github.com/fabriziosestito))
- Apply markdown rendering in check selection and result views [\#434](https://github.com/trento-project/web/pull/434) ([arbulu89](https://github.com/arbulu89))
- Include AWS and GCP handling [\#432](https://github.com/trento-project/web/pull/432) ([rtorrero](https://github.com/rtorrero))
- Show only results of selected checks [\#431](https://github.com/trento-project/web/pull/431) ([fabriziosestito](https://github.com/fabriziosestito))
- Discover azure admin user [\#430](https://github.com/trento-project/web/pull/430) ([fabriziosestito](https://github.com/fabriziosestito))
- Refactored user determination on checks execution request [\#428](https://github.com/trento-project/web/pull/428) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump axios from 0.26.1 to 0.27.0 in /assets [\#425](https://github.com/trento-project/web/pull/425) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @headlessui/react from 1.5.0 to 1.6.0 in /assets [\#424](https://github.com/trento-project/web/pull/424) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump jest from 27.5.1 to 28.0.0 in /assets [\#423](https://github.com/trento-project/web/pull/423) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump babel-jest from 27.5.1 to 28.0.0 in /assets [\#422](https://github.com/trento-project/web/pull/422) ([dependabot[bot]](https://github.com/apps/dependabot))
- Split back again the dockerfiles for gh and obs registries [\#421](https://github.com/trento-project/web/pull/421) ([arbulu89](https://github.com/arbulu89))
- Improve checks selection [\#420](https://github.com/trento-project/web/pull/420) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fix error in CI file included in prev PR [\#417](https://github.com/trento-project/web/pull/417) ([arbulu89](https://github.com/arbulu89))
- Add virtual ip parsing [\#415](https://github.com/trento-project/web/pull/415) ([rtorrero](https://github.com/rtorrero))
- Bump eslint from 8.13.0 to 8.14.0 in /assets [\#414](https://github.com/trento-project/web/pull/414) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump autoprefixer from 10.4.4 to 10.4.5 in /assets [\#413](https://github.com/trento-project/web/pull/413) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump eslint-plugin-jest from 26.1.4 to 26.1.5 in /assets [\#412](https://github.com/trento-project/web/pull/412) ([dependabot[bot]](https://github.com/apps/dependabot))
- Fix wrong system replication status [\#411](https://github.com/trento-project/web/pull/411) ([fabriziosestito](https://github.com/fabriziosestito))
- Add scheduled clusters checks execution [\#409](https://github.com/trento-project/web/pull/409) ([fabriziosestito](https://github.com/fabriziosestito))
- Host connection settings UI - missing commit [\#407](https://github.com/trento-project/web/pull/407) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Host connection settings UI [\#405](https://github.com/trento-project/web/pull/405) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Update system replication [\#404](https://github.com/trento-project/web/pull/404) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump @storybook/testing-library from 0.0.10 to 0.0.11 in /assets [\#402](https://github.com/trento-project/web/pull/402) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild from 0.14.37 to 0.14.38 in /assets [\#401](https://github.com/trento-project/web/pull/401) ([dependabot[bot]](https://github.com/apps/dependabot))
- Remove heartbeat command deduplication [\#400](https://github.com/trento-project/web/pull/400) ([fabriziosestito](https://github.com/fabriziosestito))
- Refactor register database instance handler by using multi [\#399](https://github.com/trento-project/web/pull/399) ([fabriziosestito](https://github.com/fabriziosestito))
- Make the premium EULA rely entirely on the flavor [\#398](https://github.com/trento-project/web/pull/398) ([dottorblaster](https://github.com/dottorblaster))
- remove Phoenix Framework suffix from root html title [\#396](https://github.com/trento-project/web/pull/396) ([stefanotorresi](https://github.com/stefanotorresi))
- Fix effect triggering in Checks selection [\#395](https://github.com/trento-project/web/pull/395) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add connection settings api [\#394](https://github.com/trento-project/web/pull/394) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump react-markdown from 8.0.2 to 8.0.3 in /assets [\#393](https://github.com/trento-project/web/pull/393) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild from 0.14.36 to 0.14.37 in /assets [\#392](https://github.com/trento-project/web/pull/392) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump react-redux from 8.0.0 to 8.0.1 in /assets [\#391](https://github.com/trento-project/web/pull/391) ([dependabot[bot]](https://github.com/apps/dependabot))
- Don't do anything with  duplicated or empty tags [\#390](https://github.com/trento-project/web/pull/390) ([rtorrero](https://github.com/rtorrero))
- Comment out top right buttons [\#388](https://github.com/trento-project/web/pull/388) ([fabriziosestito](https://github.com/fabriziosestito))
- Use provider checks execution [\#386](https://github.com/trento-project/web/pull/386) ([fabriziosestito](https://github.com/fabriziosestito))
- Cluster Details and Settings Part 1 [\#385](https://github.com/trento-project/web/pull/385) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add system replication / status [\#383](https://github.com/trento-project/web/pull/383) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump @storybook/testing-library from 0.0.9 to 0.0.10 in /assets [\#379](https://github.com/trento-project/web/pull/379) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump babel-loader from 8.2.4 to 8.2.5 in /assets [\#378](https://github.com/trento-project/web/pull/378) ([dependabot[bot]](https://github.com/apps/dependabot))
- Refactor CloudProvider to Provider during Cluster discovery [\#377](https://github.com/trento-project/web/pull/377) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Parse flat map format lists in SAP systems discovery payload [\#376](https://github.com/trento-project/web/pull/376) ([arbulu89](https://github.com/arbulu89))
- Ingest the published cloud service provider of a pacemaker cluster [\#373](https://github.com/trento-project/web/pull/373) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Generate admin user on init [\#372](https://github.com/trento-project/web/pull/372) ([fabriziosestito](https://github.com/fabriziosestito))
- Add checks health to checks execution completed [\#371](https://github.com/trento-project/web/pull/371) ([fabriziosestito](https://github.com/fabriziosestito))
- Add sap-system/databases linking from host overview [\#369](https://github.com/trento-project/web/pull/369) ([rtorrero](https://github.com/rtorrero))
- Bump react-redux from 7.2.8 to 8.0.0 in /assets [\#368](https://github.com/trento-project/web/pull/368) ([dependabot[bot]](https://github.com/apps/dependabot))
- Build and push containers depends on e2e test [\#365](https://github.com/trento-project/web/pull/365) ([fabriziosestito](https://github.com/fabriziosestito))
- Disallow empty tags [\#364](https://github.com/trento-project/web/pull/364) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump dayjs from 1.11.0 to 1.11.1 in /assets [\#363](https://github.com/trento-project/web/pull/363) ([dependabot[bot]](https://github.com/apps/dependabot))
- Fix Dialyzer CI cache [\#362](https://github.com/trento-project/web/pull/362) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix HostDetailsUpdated event broadcast to frontend [\#361](https://github.com/trento-project/web/pull/361) ([fabriziosestito](https://github.com/fabriziosestito))
- Put accept\_eula and settings endpoints under apikey\_auth pipeline [\#359](https://github.com/trento-project/web/pull/359) ([dottorblaster](https://github.com/dottorblaster))
- Moved routes in the correct authenticated pipes [\#358](https://github.com/trento-project/web/pull/358) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump @storybook/react from 6.4.21 to 6.4.22 in /assets [\#357](https://github.com/trento-project/web/pull/357) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-actions from 6.4.21 to 6.4.22 in /assets [\#356](https://github.com/trento-project/web/pull/356) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-essentials from 6.4.21 to 6.4.22 in /assets [\#355](https://github.com/trento-project/web/pull/355) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-links from 6.4.21 to 6.4.22 in /assets [\#354](https://github.com/trento-project/web/pull/354) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-interactions from 6.4.21 to 6.4.22 in /assets [\#353](https://github.com/trento-project/web/pull/353) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump gen\_smtp from 1.1.1 to 1.2.0 [\#352](https://github.com/trento-project/web/pull/352) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add api key settings [\#351](https://github.com/trento-project/web/pull/351) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump tailwindcss from 3.0.23 to 3.0.24 in /assets [\#350](https://github.com/trento-project/web/pull/350) ([dependabot[bot]](https://github.com/apps/dependabot))
- Eula [\#349](https://github.com/trento-project/web/pull/349) ([dottorblaster](https://github.com/dottorblaster))
- Add api auth [\#348](https://github.com/trento-project/web/pull/348) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Update e2e to use the navigation bar [\#347](https://github.com/trento-project/web/pull/347) ([arbulu89](https://github.com/arbulu89))
- Jungle green primary buttons [\#346](https://github.com/trento-project/web/pull/346) ([fabriziosestito](https://github.com/fabriziosestito))
- Add footer [\#345](https://github.com/trento-project/web/pull/345) ([fabriziosestito](https://github.com/fabriziosestito))
- Add something went wrong page [\#343](https://github.com/trento-project/web/pull/343) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump esbuild from 0.14.34 to 0.14.36 in /assets [\#342](https://github.com/trento-project/web/pull/342) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump actions/upload-artifact from 2 to 3 [\#341](https://github.com/trento-project/web/pull/341) ([dependabot[bot]](https://github.com/apps/dependabot))
- Enable the CI back on main push [\#340](https://github.com/trento-project/web/pull/340) ([rtorrero](https://github.com/rtorrero))
- Add cypress e2e tests to GH Actions [\#339](https://github.com/trento-project/web/pull/339) ([rtorrero](https://github.com/rtorrero))
- Add not found page [\#338](https://github.com/trento-project/web/pull/338) ([fabriziosestito](https://github.com/fabriziosestito))
- Pin erlang version in .tool-versions [\#335](https://github.com/trento-project/web/pull/335) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add missing field to cluster projection [\#334](https://github.com/trento-project/web/pull/334) ([fabriziosestito](https://github.com/fabriziosestito))
- Added some documentation [\#333](https://github.com/trento-project/web/pull/333) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump @storybook/addon-interactions from 6.4.20 to 6.4.21 in /assets [\#332](https://github.com/trento-project/web/pull/332) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-links from 6.4.20 to 6.4.21 in /assets [\#331](https://github.com/trento-project/web/pull/331) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump eslint-plugin-jest from 26.1.3 to 26.1.4 in /assets [\#330](https://github.com/trento-project/web/pull/330) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/react from 6.4.20 to 6.4.21 in /assets [\#329](https://github.com/trento-project/web/pull/329) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-essentials from 6.4.20 to 6.4.21 in /assets [\#328](https://github.com/trento-project/web/pull/328) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-actions from 6.4.20 to 6.4.21 in /assets [\#327](https://github.com/trento-project/web/pull/327) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump eslint from 8.12.0 to 8.13.0 in /assets [\#326](https://github.com/trento-project/web/pull/326) ([dependabot[bot]](https://github.com/apps/dependabot))
- Ensure better key presence check in the catalog reducer [\#325](https://github.com/trento-project/web/pull/325) ([dottorblaster](https://github.com/dottorblaster))
- Bump phoenix\_live\_view from 0.17.8 to 0.17.9 [\#323](https://github.com/trento-project/web/pull/323) ([dependabot[bot]](https://github.com/apps/dependabot))
- Tags animations and click outside [\#322](https://github.com/trento-project/web/pull/322) ([fabriziosestito](https://github.com/fabriziosestito))
- Cluster-e2e-tests [\#321](https://github.com/trento-project/web/pull/321) ([rtorrero](https://github.com/rtorrero))
- Health overviews [\#320](https://github.com/trento-project/web/pull/320) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Various tags component fixes [\#318](https://github.com/trento-project/web/pull/318) ([fabriziosestito](https://github.com/fabriziosestito))
- Add e2e tests [\#317](https://github.com/trento-project/web/pull/317) ([rtorrero](https://github.com/rtorrero))
- Fix tags [\#316](https://github.com/trento-project/web/pull/316) ([fabriziosestito](https://github.com/fabriziosestito))
- Do not shrink sidebar [\#315](https://github.com/trento-project/web/pull/315) ([fabriziosestito](https://github.com/fabriziosestito))
- Homepage overview UI [\#314](https://github.com/trento-project/web/pull/314) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add missing columns and uniform links [\#313](https://github.com/trento-project/web/pull/313) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump esbuild from 0.14.32 to 0.14.34 in /assets [\#312](https://github.com/trento-project/web/pull/312) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump phoenix\_live\_view from 0.17.7 to 0.17.8 [\#310](https://github.com/trento-project/web/pull/310) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @babel/core from 7.17.8 to 7.17.9 in /assets [\#311](https://github.com/trento-project/web/pull/311) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @babel/plugin-transform-modules-commonjs from 7.17.7 to 7.17.9 in /assets [\#309](https://github.com/trento-project/web/pull/309) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump swoosh from 1.6.3 to 1.6.4 [\#308](https://github.com/trento-project/web/pull/308) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump docker/metadata-action from 3.6.2 to 3.7.0 [\#307](https://github.com/trento-project/web/pull/307) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add cluster discovered health  [\#306](https://github.com/trento-project/web/pull/306) ([fabriziosestito](https://github.com/fabriziosestito))
- Homepage overview [\#302](https://github.com/trento-project/web/pull/302) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump esbuild from 0.14.31 to 0.14.32 in /assets [\#301](https://github.com/trento-project/web/pull/301) ([dependabot[bot]](https://github.com/apps/dependabot))
- Optional alerting config [\#298](https://github.com/trento-project/web/pull/298) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add grafana iframe [\#297](https://github.com/trento-project/web/pull/297) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix boolean usage in docker compose [\#295](https://github.com/trento-project/web/pull/295) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add database tag endpoint [\#294](https://github.com/trento-project/web/pull/294) ([rtorrero](https://github.com/rtorrero))
- Init grafana dashboard [\#293](https://github.com/trento-project/web/pull/293) ([fabriziosestito](https://github.com/fabriziosestito))
- Email alerting [\#291](https://github.com/trento-project/web/pull/291) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump react-redux from 7.2.7 to 7.2.8 in /assets [\#290](https://github.com/trento-project/web/pull/290) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-links from 6.4.19 to 6.4.20 in /assets [\#288](https://github.com/trento-project/web/pull/288) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-essentials from 6.4.19 to 6.4.20 in /assets [\#287](https://github.com/trento-project/web/pull/287) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-actions from 6.4.19 to 6.4.20 in /assets [\#286](https://github.com/trento-project/web/pull/286) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump prettier from 2.6.1 to 2.6.2 in /assets [\#285](https://github.com/trento-project/web/pull/285) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @storybook/addon-interactions from 6.4.19 to 6.4.20 in /assets [\#284](https://github.com/trento-project/web/pull/284) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild from 0.14.29 to 0.14.31 in /assets [\#283](https://github.com/trento-project/web/pull/283) ([dependabot[bot]](https://github.com/apps/dependabot))
- Update catalog frontend [\#281](https://github.com/trento-project/web/pull/281) ([arbulu89](https://github.com/arbulu89))
- Paginated tables [\#280](https://github.com/trento-project/web/pull/280) ([dottorblaster](https://github.com/dottorblaster))
- Bump react-redux from 7.2.6 to 7.2.7 in /assets [\#279](https://github.com/trento-project/web/pull/279) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @reduxjs/toolkit from 1.8.0 to 1.8.1 in /assets [\#278](https://github.com/trento-project/web/pull/278) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump react-router-dom from 6.2.2 to 6.3.0 in /assets [\#277](https://github.com/trento-project/web/pull/277) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump react-markdown from 8.0.1 to 8.0.2 in /assets [\#276](https://github.com/trento-project/web/pull/276) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump httpoison from 1.8.0 to 1.8.1 [\#275](https://github.com/trento-project/web/pull/275) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add prometheus target discovery endpoint [\#274](https://github.com/trento-project/web/pull/274) ([fabriziosestito](https://github.com/fabriziosestito))
- Add ssh address to host [\#273](https://github.com/trento-project/web/pull/273) ([fabriziosestito](https://github.com/fabriziosestito))
- Rename and clean-up dtos [\#272](https://github.com/trento-project/web/pull/272) ([fabriziosestito](https://github.com/fabriziosestito))
- CibLastWritten broadcast [\#271](https://github.com/trento-project/web/pull/271) ([dottorblaster](https://github.com/dottorblaster))
- Fix typo [\#270](https://github.com/trento-project/web/pull/270) ([ajaeger](https://github.com/ajaeger))
- Fix heartbeat channel broadcast [\#269](https://github.com/trento-project/web/pull/269) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix heartbeat icon [\#268](https://github.com/trento-project/web/pull/268) ([fabriziosestito](https://github.com/fabriziosestito))
- Remove unused feature flag [\#266](https://github.com/trento-project/web/pull/266) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix filters, links and cluster actions [\#265](https://github.com/trento-project/web/pull/265) ([fabriziosestito](https://github.com/fabriziosestito))
- Store tags state [\#264](https://github.com/trento-project/web/pull/264) ([rtorrero](https://github.com/rtorrero))
- Use proper navbar icons [\#262](https://github.com/trento-project/web/pull/262) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump esbuild from 0.14.28 to 0.14.29 in /assets [\#261](https://github.com/trento-project/web/pull/261) ([dependabot[bot]](https://github.com/apps/dependabot))
- Close filters when clicking outside [\#260](https://github.com/trento-project/web/pull/260) ([fabriziosestito](https://github.com/fabriziosestito))
- Add checks execution domain logic [\#256](https://github.com/trento-project/web/pull/256) ([fabriziosestito](https://github.com/fabriziosestito))
- Cluster details with IPs and filters enabled app-wide [\#254](https://github.com/trento-project/web/pull/254) ([dottorblaster](https://github.com/dottorblaster))
- Fix Trento.Type error handling and adds tests [\#252](https://github.com/trento-project/web/pull/252) ([fabriziosestito](https://github.com/fabriziosestito))
- Flavor determination in about api [\#250](https://github.com/trento-project/web/pull/250) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump eslint from 8.11.0 to 8.12.0 in /assets [\#247](https://github.com/trento-project/web/pull/247) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild from 0.14.27 to 0.14.28 in /assets [\#246](https://github.com/trento-project/web/pull/246) ([dependabot[bot]](https://github.com/apps/dependabot))
- Fix dump scenario [\#245](https://github.com/trento-project/web/pull/245) ([fabriziosestito](https://github.com/fabriziosestito))
- Sap system details improvements [\#244](https://github.com/trento-project/web/pull/244) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Serialize events in json and add DSL [\#243](https://github.com/trento-project/web/pull/243) ([fabriziosestito](https://github.com/fabriziosestito))
- Sap system detail UI [\#240](https://github.com/trento-project/web/pull/240) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump minimist from 1.2.5 to 1.2.6 in /assets [\#239](https://github.com/trento-project/web/pull/239) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump floki from 0.32.0 to 0.32.1 [\#238](https://github.com/trento-project/web/pull/238) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump prettier from 2.6.0 to 2.6.1 in /assets [\#237](https://github.com/trento-project/web/pull/237) ([dependabot[bot]](https://github.com/apps/dependabot))
- More tests [\#236](https://github.com/trento-project/web/pull/236) ([rtorrero](https://github.com/rtorrero))
- Sap system detail backend [\#235](https://github.com/trento-project/web/pull/235) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fix HostAddedToCluster projection [\#234](https://github.com/trento-project/web/pull/234) ([fabriziosestito](https://github.com/fabriziosestito))
- Add tags tests [\#232](https://github.com/trento-project/web/pull/232) ([rtorrero](https://github.com/rtorrero))
- Add checks integration service and mock runner \(part 1\) [\#231](https://github.com/trento-project/web/pull/231) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump babel-loader from 8.2.3 to 8.2.4 in /assets [\#230](https://github.com/trento-project/web/pull/230) ([dependabot[bot]](https://github.com/apps/dependabot))
- Cluster details [\#229](https://github.com/trento-project/web/pull/229) ([dottorblaster](https://github.com/dottorblaster))
- Live sap systems health [\#228](https://github.com/trento-project/web/pull/228) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Use table component for livefeed [\#227](https://github.com/trento-project/web/pull/227) ([dottorblaster](https://github.com/dottorblaster))
- Project details when cluster is registered [\#226](https://github.com/trento-project/web/pull/226) ([fabriziosestito](https://github.com/fabriziosestito))
- Databases overview reactiveness [\#225](https://github.com/trento-project/web/pull/225) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump peter-evans/repository-dispatch from 1 to 2 [\#224](https://github.com/trento-project/web/pull/224) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump actions/cache from 2 to 3 [\#223](https://github.com/trento-project/web/pull/223) ([dependabot[bot]](https://github.com/apps/dependabot))
- Databases overview [\#218](https://github.com/trento-project/web/pull/218) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Publish telemetry [\#217](https://github.com/trento-project/web/pull/217) ([fabriziosestito](https://github.com/fabriziosestito))
- Remove unnecessary query when updating read models [\#216](https://github.com/trento-project/web/pull/216) ([rtorrero](https://github.com/rtorrero))
- Fix SapSystems Tags existence checking [\#215](https://github.com/trento-project/web/pull/215) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fix eslint execution [\#214](https://github.com/trento-project/web/pull/214) ([dottorblaster](https://github.com/dottorblaster))
- Fix sap systems state [\#213](https://github.com/trento-project/web/pull/213) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Add UI tagging for hosts, clusters and sapsystems [\#212](https://github.com/trento-project/web/pull/212) ([rtorrero](https://github.com/rtorrero))
- Bump @babel/core from 7.17.7 to 7.17.8 in /assets [\#211](https://github.com/trento-project/web/pull/211) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump fun\_with\_flags\_ui from 0.7.2 to 0.8.0 [\#210](https://github.com/trento-project/web/pull/210) ([dependabot[bot]](https://github.com/apps/dependabot))
- Enable warnings as errors in CI build step [\#208](https://github.com/trento-project/web/pull/208) ([fabriziosestito](https://github.com/fabriziosestito))
- Project Database and SAP System health changed event [\#206](https://github.com/trento-project/web/pull/206) ([fabriziosestito](https://github.com/fabriziosestito))
- Extreme makeover filters edition [\#205](https://github.com/trento-project/web/pull/205) ([dottorblaster](https://github.com/dottorblaster))
- Fixed state nullability check [\#203](https://github.com/trento-project/web/pull/203) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Fixed element indexing in react components [\#202](https://github.com/trento-project/web/pull/202) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Clean-up architecture and project structure [\#199](https://github.com/trento-project/web/pull/199) ([fabriziosestito](https://github.com/fabriziosestito))
- Rename application [\#197](https://github.com/trento-project/web/pull/197) ([fabriziosestito](https://github.com/fabriziosestito))
- Add Live update to SAP Systems Overview [\#196](https://github.com/trento-project/web/pull/196) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Order instances by instance number [\#195](https://github.com/trento-project/web/pull/195) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump autoprefixer from 10.4.3 to 10.4.4 in /assets [\#194](https://github.com/trento-project/web/pull/194) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump postcss from 8.4.11 to 8.4.12 in /assets [\#193](https://github.com/trento-project/web/pull/193) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild-plugin-path-alias from 1.0.5 to 1.0.6 in /assets [\#192](https://github.com/trento-project/web/pull/192) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add onAdd and onRemove callbacks to Tags [\#191](https://github.com/trento-project/web/pull/191) ([rtorrero](https://github.com/rtorrero))
- Host details [\#188](https://github.com/trento-project/web/pull/188) ([dottorblaster](https://github.com/dottorblaster))
- Collapsible sap system overview details [\#187](https://github.com/trento-project/web/pull/187) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Minor ui improvements on SAP systems overview [\#182](https://github.com/trento-project/web/pull/182) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Project  host telemetry data [\#181](https://github.com/trento-project/web/pull/181) ([fabriziosestito](https://github.com/fabriziosestito))
- Sap system overview details [\#180](https://github.com/trento-project/web/pull/180) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump prettier from 2.5.1 to 2.6.0 in /assets [\#179](https://github.com/trento-project/web/pull/179) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump postcss from 8.4.8 to 8.4.11 in /assets [\#178](https://github.com/trento-project/web/pull/178) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump autoprefixer from 10.4.2 to 10.4.3 in /assets [\#177](https://github.com/trento-project/web/pull/177) ([dependabot[bot]](https://github.com/apps/dependabot))
- Store discovery events and add dump scenario task/script [\#176](https://github.com/trento-project/web/pull/176) ([fabriziosestito](https://github.com/fabriziosestito))
- Refactor discovery [\#174](https://github.com/trento-project/web/pull/174) ([fabriziosestito](https://github.com/fabriziosestito))
- Reactive sap systems overview - listing [\#173](https://github.com/trento-project/web/pull/173) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump dayjs from 1.10.8 to 1.11.0 in /assets [\#172](https://github.com/trento-project/web/pull/172) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild from 0.14.25 to 0.14.27 in /assets [\#171](https://github.com/trento-project/web/pull/171) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @babel/core from 7.17.5 to 7.17.7 in /assets [\#170](https://github.com/trento-project/web/pull/170) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add HANA cluster details [\#168](https://github.com/trento-project/web/pull/168) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix sles subscriptions count [\#167](https://github.com/trento-project/web/pull/167) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Bump eslint from 8.10.0 to 8.11.0 in /assets [\#166](https://github.com/trento-project/web/pull/166) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump eslint-plugin-react from 7.29.3 to 7.29.4 in /assets [\#165](https://github.com/trento-project/web/pull/165) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add designated controller field [\#164](https://github.com/trento-project/web/pull/164) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix application instance registration [\#163](https://github.com/trento-project/web/pull/163) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Switch to erlang term event serializer [\#162](https://github.com/trento-project/web/pull/162) ([fabriziosestito](https://github.com/fabriziosestito))
- Add feature flags [\#161](https://github.com/trento-project/web/pull/161) ([fabriziosestito](https://github.com/fabriziosestito))
- New layout [\#160](https://github.com/trento-project/web/pull/160) ([dottorblaster](https://github.com/dottorblaster))
- Make tables automatically filter themselves [\#159](https://github.com/trento-project/web/pull/159) ([dottorblaster](https://github.com/dottorblaster))
- Several fix and cleanup galore [\#158](https://github.com/trento-project/web/pull/158) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump axios from 0.26.0 to 0.26.1 in /assets [\#157](https://github.com/trento-project/web/pull/157) ([dependabot[bot]](https://github.com/apps/dependabot))
- Adds scenario fixtures [\#156](https://github.com/trento-project/web/pull/156) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Use table cluster lists [\#154](https://github.com/trento-project/web/pull/154) ([rtorrero](https://github.com/rtorrero))
- Use the new react table component in hosts list [\#153](https://github.com/trento-project/web/pull/153) ([rtorrero](https://github.com/rtorrero))
- Tags component [\#150](https://github.com/trento-project/web/pull/150) ([dottorblaster](https://github.com/dottorblaster))
- Bump postcss from 8.4.7 to 8.4.8 in /assets [\#149](https://github.com/trento-project/web/pull/149) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump esbuild from 0.14.24 to 0.14.25 in /assets [\#148](https://github.com/trento-project/web/pull/148) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add provider details data [\#145](https://github.com/trento-project/web/pull/145) ([arbulu89](https://github.com/arbulu89))
- Add an about page [\#144](https://github.com/trento-project/web/pull/144) ([dottorblaster](https://github.com/dottorblaster))
- Bump esbuild from 0.14.23 to 0.14.24 in /assets [\#143](https://github.com/trento-project/web/pull/143) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump eslint-plugin-react from 7.29.2 to 7.29.3 in /assets [\#142](https://github.com/trento-project/web/pull/142) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add SAP systems [\#141](https://github.com/trento-project/web/pull/141) ([fabriziosestito](https://github.com/fabriziosestito))
- Add provider updated event and frontend updates [\#140](https://github.com/trento-project/web/pull/140) ([arbulu89](https://github.com/arbulu89))
- Bump @heroicons/react from 1.0.5 to 1.0.6 in /assets [\#139](https://github.com/trento-project/web/pull/139) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add subscriptions projection [\#138](https://github.com/trento-project/web/pull/138) ([dottorblaster](https://github.com/dottorblaster))
- Bump actions/checkout from 2 to 3 [\#137](https://github.com/trento-project/web/pull/137) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump react-router-dom from 6.2.1 to 6.2.2 in /assets [\#136](https://github.com/trento-project/web/pull/136) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump dayjs from 1.10.7 to 1.10.8 in /assets [\#135](https://github.com/trento-project/web/pull/135) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump actions/setup-node from 2 to 3 [\#134](https://github.com/trento-project/web/pull/134) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add eslint config [\#132](https://github.com/trento-project/web/pull/132) ([dottorblaster](https://github.com/dottorblaster))
- Add prod release [\#131](https://github.com/trento-project/web/pull/131) ([fabriziosestito](https://github.com/fabriziosestito))
- Storybook and a table component [\#130](https://github.com/trento-project/web/pull/130) ([dottorblaster](https://github.com/dottorblaster))
- Some login page fixes [\#129](https://github.com/trento-project/web/pull/129) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump credo from 1.6.3 to 1.6.4 [\#128](https://github.com/trento-project/web/pull/128) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @reduxjs/toolkit from 1.7.2 to 1.8.0 in /assets [\#127](https://github.com/trento-project/web/pull/127) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add Tronto.AggregateCase and Tronto.Factory and refactor tests [\#126](https://github.com/trento-project/web/pull/126) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix for gigalixir which I inadvertently broke [\#125](https://github.com/trento-project/web/pull/125) ([dottorblaster](https://github.com/dottorblaster))
- Fix static assets deployment using the new config [\#124](https://github.com/trento-project/web/pull/124) ([dottorblaster](https://github.com/dottorblaster))
- Add dockerfiles [\#122](https://github.com/trento-project/web/pull/122) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump postcss from 8.4.6 to 8.4.7 in /assets [\#121](https://github.com/trento-project/web/pull/121) ([dependabot[bot]](https://github.com/apps/dependabot))
- Switch esbuild to a build script [\#120](https://github.com/trento-project/web/pull/120) ([dottorblaster](https://github.com/dottorblaster))
- Bump postgrex from 0.16.1 to 0.16.2 [\#119](https://github.com/trento-project/web/pull/119) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump phoenix\_live\_dashboard from 0.6.4 to 0.6.5 [\#118](https://github.com/trento-project/web/pull/118) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @headlessui/react from 1.4.3 to 1.5.0 in /assets [\#117](https://github.com/trento-project/web/pull/117) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.22 to 3.0.23 in /assets [\#116](https://github.com/trento-project/web/pull/116) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump typed\_struct from 0.2.1 to 0.3.0 [\#115](https://github.com/trento-project/web/pull/115) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump swoosh from 1.6.2 to 1.6.3 [\#114](https://github.com/trento-project/web/pull/114) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump axios from 0.25.0 to 0.26.0 in /assets [\#113](https://github.com/trento-project/web/pull/113) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.21 to 3.0.22 in /assets [\#112](https://github.com/trento-project/web/pull/112) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.19 to 3.0.21 in /assets [\#111](https://github.com/trento-project/web/pull/111) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add basic mail alerting [\#110](https://github.com/trento-project/web/pull/110) ([fabriziosestito](https://github.com/fabriziosestito))
- Add cluster health feature [\#109](https://github.com/trento-project/web/pull/109) ([dottorblaster](https://github.com/dottorblaster))
- Bump credo from 1.6.2 to 1.6.3 [\#108](https://github.com/trento-project/web/pull/108) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump phoenix\_live\_view from 0.17.6 to 0.17.7 [\#107](https://github.com/trento-project/web/pull/107) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.18 to 3.0.19 in /assets [\#106](https://github.com/trento-project/web/pull/106) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add hammering Stefano and add a margin to host health [\#105](https://github.com/trento-project/web/pull/105) ([dottorblaster](https://github.com/dottorblaster))
- Add a new clusters count [\#104](https://github.com/trento-project/web/pull/104) ([dottorblaster](https://github.com/dottorblaster))
- Implement hamburger menu for clusters table [\#103](https://github.com/trento-project/web/pull/103) ([dottorblaster](https://github.com/dottorblaster))
- Bump gettext from 0.19.0 to 0.19.1 [\#102](https://github.com/trento-project/web/pull/102) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump phoenix\_live\_dashboard from 0.6.3 to 0.6.4 [\#100](https://github.com/trento-project/web/pull/100) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump swoosh from 1.6.1 to 1.6.2 [\#99](https://github.com/trento-project/web/pull/99) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @reduxjs/toolkit from 1.7.1 to 1.7.2 in /assets [\#98](https://github.com/trento-project/web/pull/98) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump postcss from 8.4.5 to 8.4.6 in /assets [\#97](https://github.com/trento-project/web/pull/97) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add checks execution [\#96](https://github.com/trento-project/web/pull/96) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump phoenix\_live\_dashboard from 0.6.2 to 0.6.3 [\#95](https://github.com/trento-project/web/pull/95) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump swoosh from 1.6.0 to 1.6.1 [\#94](https://github.com/trento-project/web/pull/94) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.17 to 3.0.18 in /assets [\#93](https://github.com/trento-project/web/pull/93) ([dependabot[bot]](https://github.com/apps/dependabot))
- Rename id variables [\#92](https://github.com/trento-project/web/pull/92) ([fabriziosestito](https://github.com/fabriziosestito))
- Format the date in the live feed and make the whole thing smaller [\#91](https://github.com/trento-project/web/pull/91) ([dottorblaster](https://github.com/dottorblaster))
- Bump nanoid from 3.1.30 to 3.2.0 in /assets [\#90](https://github.com/trento-project/web/pull/90) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.16 to 3.0.17 in /assets [\#89](https://github.com/trento-project/web/pull/89) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump postgrex from 0.16.0 to 0.16.1 [\#88](https://github.com/trento-project/web/pull/88) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.15 to 3.0.16 in /assets [\#87](https://github.com/trento-project/web/pull/87) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump ecto\_sql from 3.7.1 to 3.7.2 [\#86](https://github.com/trento-project/web/pull/86) ([dependabot[bot]](https://github.com/apps/dependabot))
- Pin Elixir version to 1.13 minor, without patches [\#85](https://github.com/trento-project/web/pull/85) ([dottorblaster](https://github.com/dottorblaster))
- Add HostDetailsUpdated host\_projector tests [\#84](https://github.com/trento-project/web/pull/84) ([rtorrero](https://github.com/rtorrero))
- Add cluster view [\#83](https://github.com/trento-project/web/pull/83) ([fabriziosestito](https://github.com/fabriziosestito))
- Add EventStore dashboard [\#82](https://github.com/trento-project/web/pull/82) ([fabriziosestito](https://github.com/fabriziosestito))
- Add a live feed implementation for host registration [\#81](https://github.com/trento-project/web/pull/81) ([dottorblaster](https://github.com/dottorblaster))
- Bump axios from 0.24.0 to 0.25.0 in /assets [\#79](https://github.com/trento-project/web/pull/79) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump credo from 1.6.1 to 1.6.2 [\#78](https://github.com/trento-project/web/pull/78) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump swoosh from 1.5.2 to 1.6.0 [\#77](https://github.com/trento-project/web/pull/77) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.13 to 3.0.15 in /assets [\#76](https://github.com/trento-project/web/pull/76) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump @headlessui/react from 1.4.2 to 1.4.3 in /assets [\#75](https://github.com/trento-project/web/pull/75) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add cluster discovery [\#74](https://github.com/trento-project/web/pull/74) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump tailwindcss from 3.0.12 to 3.0.13 in /assets [\#73](https://github.com/trento-project/web/pull/73) ([dependabot[bot]](https://github.com/apps/dependabot))
- Emit host details updated event [\#72](https://github.com/trento-project/web/pull/72) ([fabriziosestito](https://github.com/fabriziosestito))
- Fix host heartbeat status stuck to unknown if heartbeat arrives prior registration [\#71](https://github.com/trento-project/web/pull/71) ([fabriziosestito](https://github.com/fabriziosestito))
- Add Trento logo [\#70](https://github.com/trento-project/web/pull/70) ([dottorblaster](https://github.com/dottorblaster))
- Add heartbeat domain events,  endpoint, and reactive frontend [\#67](https://github.com/trento-project/web/pull/67) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump autoprefixer from 10.4.1 to 10.4.2 in /assets [\#66](https://github.com/trento-project/web/pull/66) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.11 to 3.0.12 in /assets [\#65](https://github.com/trento-project/web/pull/65) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump react-hot-toast from 2.1.1 to 2.2.0 in /assets [\#64](https://github.com/trento-project/web/pull/64) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump elixir version to 1.13.1 [\#62](https://github.com/trento-project/web/pull/62) ([fabriziosestito](https://github.com/fabriziosestito))
- Rename purge in content [\#61](https://github.com/trento-project/web/pull/61) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump tailwindcss from 3.0.10 to 3.0.11 in /assets [\#59](https://github.com/trento-project/web/pull/59) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump phoenix from 1.6.5 to 1.6.6 [\#51](https://github.com/trento-project/web/pull/51) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.9 to 3.0.10 in /assets [\#50](https://github.com/trento-project/web/pull/50) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 3.0.8 to 3.0.9 in /assets [\#44](https://github.com/trento-project/web/pull/44) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump domo from 1.5.1 to 1.5.2 [\#43](https://github.com/trento-project/web/pull/43) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add RegisterHost command test [\#42](https://github.com/trento-project/web/pull/42) ([fabriziosestito](https://github.com/fabriziosestito))
- Add validate middleware tests [\#41](https://github.com/trento-project/web/pull/41) ([fabriziosestito](https://github.com/fabriziosestito))
- Switch to credo strict [\#39](https://github.com/trento-project/web/pull/39) ([fabriziosestito](https://github.com/fabriziosestito))
- Add commands validation [\#38](https://github.com/trento-project/web/pull/38) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump autoprefixer from 10.4.0 to 10.4.1 in /assets [\#36](https://github.com/trento-project/web/pull/36) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add collector endpoint, host discovery integration event handler and monitoring context [\#34](https://github.com/trento-project/web/pull/34) ([fabriziosestito](https://github.com/fabriziosestito))
- Bump tailwindcss from 3.0.7 to 3.0.8 in /assets [\#33](https://github.com/trento-project/web/pull/33) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump phoenix from 1.6.2 to 1.6.5 [\#31](https://github.com/trento-project/web/pull/31) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump gettext from 0.18.2 to 0.19.0 [\#30](https://github.com/trento-project/web/pull/30) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump postcss from 8.4.4 to 8.4.5 in /assets [\#27](https://github.com/trento-project/web/pull/27) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump tailwindcss from 2.2.19 to 3.0.7 in /assets [\#26](https://github.com/trento-project/web/pull/26) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump react-router-dom from 6.0.2 to 6.2.1 in /assets [\#25](https://github.com/trento-project/web/pull/25) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump styfle/cancel-workflow-action from 0.6.0 to 0.9.1 [\#24](https://github.com/trento-project/web/pull/24) ([dependabot[bot]](https://github.com/apps/dependabot))
- Bump mhanberg/gigalixir-action from 0.6.1 to 0.6.2 [\#23](https://github.com/trento-project/web/pull/23) ([dependabot[bot]](https://github.com/apps/dependabot))
- Add persistent session [\#22](https://github.com/trento-project/web/pull/22) ([fabriziosestito](https://github.com/fabriziosestito))
- Add Host aggregate and Host registration command/event [\#21](https://github.com/trento-project/web/pull/21) ([fabriziosestito](https://github.com/fabriziosestito))
- Make the sidebar behave like a real one, plus JS refactor [\#20](https://github.com/trento-project/web/pull/20) ([dottorblaster](https://github.com/dottorblaster))
- Adds a mix start task to setup the local environment [\#19](https://github.com/trento-project/web/pull/19) ([nelsonkopliku](https://github.com/nelsonkopliku))
- Heartbeat part I [\#18](https://github.com/trento-project/web/pull/18) ([fabriziosestito](https://github.com/fabriziosestito))
- Add routes and links to them [\#17](https://github.com/trento-project/web/pull/17) ([dottorblaster](https://github.com/dottorblaster))
- Add login page [\#15](https://github.com/trento-project/web/pull/15) ([fabriziosestito](https://github.com/fabriziosestito))
- Add branding colors [\#14](https://github.com/trento-project/web/pull/14) ([fabriziosestito](https://github.com/fabriziosestito))
- Cleanup layout, use EOS typography [\#11](https://github.com/trento-project/web/pull/11) ([fabriziosestito](https://github.com/fabriziosestito))
- Remove JIT from tailwind, add layout, add react router home [\#8](https://github.com/trento-project/web/pull/8) ([dottorblaster](https://github.com/dottorblaster))
- Single page app [\#7](https://github.com/trento-project/web/pull/7) ([dottorblaster](https://github.com/dottorblaster))
- Add ci [\#3](https://github.com/trento-project/web/pull/3) ([fabriziosestito](https://github.com/fabriziosestito))
- First setup [\#2](https://github.com/trento-project/web/pull/2) ([fabriziosestito](https://github.com/fabriziosestito))


